From 712e07f2beb42ee6a4163d88daea1ee9a6e466b3 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 31 2016 19:51:49 +0000
Subject: [PATCH 381/1001] Add forgotten files.


---

diff --git a/hubs/backend/triage.py b/hubs/backend/triage.py
new file mode 100755
index 0000000..fac1bb0
--- /dev/null
+++ b/hubs/backend/triage.py
@@ -0,0 +1,119 @@
+#!/usr/bin/env python
+""" hubs backend triage process.
+
+This is step 2 of the backend cascading pipeline.
+
+consumer -> redis --+-> triage process -+-> redis --+-> worker process
+                    |          .        |           |          .
+                    +-> triage process -+           +-> worker process
+                               .                               .
+                               .                               .
+                               .                               .
+
+There could be multiple triage processing running as a farm that pulls work
+from a redis queue, fed by the fedmsg consumer.  The job of the triage process
+is to take raw fedmsg messages and decide if any widgets should be invalidated
+by them.  They don't actually do the invalidating and rebuilding themselves,
+though.  If they see that invalidation is required, they put a new task on an
+'outbound' redis queue for a worker process from the worker farm to pick up and
+handle.
+"""
+
+import hubs.app
+import hubs.models
+
+import hubs.widgets.base
+
+import fedmsg.config
+import fedmsg.meta
+config = fedmsg.config.load_config()
+
+import retask.queue
+
+import json
+import random
+import sys
+import logging
+import logging.config
+log = logging.getLogger('hubs.backend.triage')
+
+def triage(session, outbound, msg):
+    topic = msg['topic']
+    category = topic.split('.')[3]
+
+    for suffix in config['hubs.junk_suffixes']:
+        if topic.endswith(suffix):
+            log.debug("  Dropping junk %r", topic)
+            return
+
+    # Get a list of all our widgets:
+    log.debug("Querying for all widgets.")
+    widgets = session.query(hubs.models.Widget).all()
+
+    # Randomize so that all the triage daemons work on widgets in different
+    # orders.  This should hopefully prevent cache thrashing.
+    log.debug("Randomizing list of all widgets.")
+    random.shuffle(widgets)
+
+    log.debug("Checking should_invalidate for all widgets.")
+    for widget in widgets:
+
+        check = widget.module.should_invalidate
+
+        # Do some pre-flight checks before calling should_invalidate
+        if hasattr(check, 'hints'):
+            if check.hints['topics']:
+                if topic not in check.hints['topics']:
+                    continue
+            if check.hints['categories']:
+                if category not in check.hints['categories']:
+                    continue
+
+        if check(msg, session, widget):
+            yield retask.task.Task(json.dumps({
+                'idx': widget.idx,
+                'msg_id': msg['msg_id'],
+            }))
+
+
+def main(args):
+    logging.config.dictConfig(config['logging'])
+    logging.basicConfig()
+
+    fedmsg.meta.make_processors(**config)
+
+    # XXX - for flask.url_for to work
+    hubs.app.app.config['SERVER_NAME'] = '0.0.0.0:5000'
+
+    inbound_name = config['hubs.redis.triage-queue-name']
+    outbound_name = config['hubs.redis.work-queue-name']
+
+    log.info("Triage proc starting.  Moving from %r to %r." % (inbound_name, outbound_name))
+
+    inbound = retask.queue.Queue(inbound_name)
+    inbound.connect()
+    outbound = retask.queue.Queue(outbound_name)
+    outbound.connect()
+
+    try:
+        log.info("Entering triage loop.")
+        while True:
+            task = inbound.wait()  # Wait forever...  timeout is optional.
+            msg = json.loads(task.data)
+            log.info(
+                "(triage backlog: %r, work backlog: %r)  Working on %r %r",
+                inbound.length, outbound.length, msg['msg_id'], msg['topic'],
+            )
+            session = hubs.models.init(config['hubs.sqlalchemy.uri'])
+            with hubs.app.app.app_context():  # so url_for works
+                for task in triage(session, outbound, msg):
+                    log.debug("  Triage sending %r to workers." % task)
+                    outbound.enqueue(task)
+            log.debug("  Done with triage of %r.", msg['msg_id'])
+    except KeyboardInterrupt:
+        pass
+
+    return 0
+
+if __name__ == '__main__':
+    sys.exit(main(sys.argv))

